"""
    AbstractBoundaryValueDiffEqCache

Abstract Type for all BoundaryValueDiffEqCore Caches.

### Interface Functions

  - `SciMLBase.isinplace(cache)`: whether or not the solver is inplace.
  - `Base.eltype(cache)`: get the element type of the cache.
"""
abstract type AbstractBoundaryValueDiffEqCache end

function SciMLBase.isinplace(cache::AbstractBoundaryValueDiffEqCache)
    return SciMLBase.isinplace(cache.prob)
end

# Currently there are some problems with the default NonlinearSolver selection for
# BoundaryValueDiffEq
# See https://github.com/SciML/BoundaryValueDiffEq.jl/issues/175
# and https://github.com/SciML/BoundaryValueDiffEq.jl/issues/163
# These are not meant to be user facing and we should delete these once those issues are
# resolved
function __FastShortcutBVPCompatibleNLLSPolyalg(
        ::Type{T} = Float64; concrete_jac = nothing,
        linsolve = nothing, autodiff = nothing, kwargs...
    ) where {T}
    if T <: Complex
        algs = (
            GaussNewton(; concrete_jac, linsolve, autodiff, kwargs...),
            LevenbergMarquardt(; linsolve, autodiff, disable_geodesic = Val(true), kwargs...),
            LevenbergMarquardt(; linsolve, autodiff, kwargs...),
        )
    else
        algs = (
            GaussNewton(; concrete_jac, linsolve, autodiff, kwargs...),
            LevenbergMarquardt(; linsolve, disable_geodesic = Val(true), autodiff, kwargs...),
            TrustRegion(; concrete_jac, linsolve, autodiff, kwargs...),
            GaussNewton(;
                concrete_jac, linsolve, linesearch = BackTracking(), autodiff, kwargs...
            ),
            LevenbergMarquardt(; linsolve, autodiff, kwargs...),
        )
    end
    return NonlinearSolvePolyAlgorithm(algs)
end

function __FastShortcutBVPCompatibleNonlinearPolyalg(
        ::Type{T} = Float64; concrete_jac = nothing,
        linsolve = nothing, autodiff = nothing
    ) where {T}
    if T <: Complex
        algs = (NewtonRaphson(; concrete_jac, linsolve, autodiff),)
    else
        algs = (
            NewtonRaphson(; concrete_jac, linsolve, autodiff),
            NewtonRaphson(; concrete_jac, linsolve, linesearch = BackTracking(), autodiff),
            TrustRegion(; concrete_jac, linsolve, autodiff),
        )
    end
    return NonlinearSolvePolyAlgorithm(algs)
end

function __FastShortcutNonlinearPolyalg(
        ::Type{T} = Float64; concrete_jac = nothing,
        linsolve = nothing, autodiff = nothing
    ) where {T}
    if T <: Complex
        algs = (NewtonRaphson(; concrete_jac, linsolve, autodiff),)
    else
        algs = (
            NewtonRaphson(; concrete_jac, linsolve, autodiff),
            NewtonRaphson(; concrete_jac, linsolve, linesearch = BackTracking(), autodiff),
            TrustRegion(; concrete_jac, linsolve, autodiff),
        )
    end
    return NonlinearSolvePolyAlgorithm(algs)
end

"""
    __concrete_solve_algorithm(prob, nlsolve_alg, optimize_alg)

Automatic solver choosing according to the input solver.
If none of the solvers are specified, we use nonlinear solvers from NonlinearSolve.jl.
If both of the nonlinear solver and optimization solver are specified, we throw an error.
If only one of the nonlinear solver and optimization solver is specified, we use that solver.
"""
@inline __concrete_solve_algorithm(prob, alg) = alg
@inline __concrete_solve_algorithm(prob, alg, ::Nothing) = alg
@inline __concrete_solve_algorithm(prob, ::Nothing, alg) = alg
@inline __concrete_solve_algorithm(
    prob,
    alg1,
    alg2
) = error("Both `nlsolve` and `optimize` are specified in the algorithm, but only one of them is allowed. Please specify only one of them.")
@inline function __concrete_solve_algorithm(prob, ::Nothing)
    if prob isa NonlinearLeastSquaresProblem
        return __FastShortcutBVPCompatibleNLLSPolyalg(eltype(prob.u0))
    else
        return __FastShortcutBVPCompatibleNonlinearPolyalg(eltype(prob.u0))
    end
end
@inline function __concrete_solve_algorithm(prob, ::Nothing, ::Nothing)
    if prob isa NonlinearLeastSquaresProblem
        return __FastShortcutBVPCompatibleNLLSPolyalg(eltype(prob.u0))
    else
        return __FastShortcutBVPCompatibleNonlinearPolyalg(eltype(prob.u0))
    end
end

# Some optimization algorithms (solvers from interfacing packages) don't support the __solve(prob) interface
@inline __internal_solve(
    prob::Union{SciMLBase.NonlinearProblem, SciMLBase.NonlinearLeastSquaresProblem},
    alg; kwargs...
) = __solve(prob, alg; kwargs...)
@inline __internal_solve(
    prob::SciMLBase.OptimizationProblem, alg;
    kwargs...
) = OptimizationBase.solve(prob, alg; kwargs...)

"""
    AbstractErrorControl

Abstract type for different error control methods.
"""
abstract type AbstractErrorControl end

"""
    GlobalErrorControlMethod

Abstract type for different global error control methods, and according to the different global error estimation methods, there are

  - `HOErrorControl`: Higher order global error estimation method
  - `REErrorControl`: Richardson extrapolation global error estimation method
"""
abstract type GlobalErrorControlMethod end

"""
    DefectControl(; defect_threshold = 0.1)

Defect estimation method with defect defined as

```math
\\text{defect} = \\max\\frac{S'(x) - f(x,S(x))}{1 + |f(x,S(x))|}
```

Defect controller, with the maximum `defect_threshold` as 0.1, when the estimating defect is greater than the `defect_threshold`, the mesh will be refined.
"""
struct DefectControl{T} <: AbstractErrorControl
    defect_threshold::T

    function DefectControl(; defect_threshold = 0.1)
        return new{typeof(defect_threshold)}(defect_threshold)
    end
end

"""
    GlobalErrorControl(; method = HOErrorControl())

Global error controller, use high order global error estimation method `HOErrorControl` as default.
"""
struct GlobalErrorControl <: AbstractErrorControl
    method::GlobalErrorControlMethod

    function GlobalErrorControl(; method = HOErrorControl())
        return new(method)
    end
end

"""
    SequentialErrorControl(; defect = DefectControl(), global_error = GlobalErrorControl())

First use the defect controller, if the defect is satisfying, then use global error controller.
"""
struct SequentialErrorControl <: AbstractErrorControl
    defect::DefectControl
    global_error::GlobalErrorControl

    function SequentialErrorControl(; defect = DefectControl(), global_error = GlobalErrorControl())
        return new(defect, global_error)
    end
end

"""
    HybridErrorControl(; DE = 1.0, GE = 1.0, defect = DefectControl(), global_error = GlobalErrorControl())

Control both of the defect and global error, where the error norm is the linear combination of the defect and global error.
"""
struct HybridErrorControl{T1, T2} <: AbstractErrorControl
    DE::T1
    GE::T2
    defect::DefectControl
    global_error::GlobalErrorControl

    function HybridErrorControl(;
            DE = 1.0, GE = 1.0, defect = DefectControl(),
            global_error = GlobalErrorControl()
        )
        return new{typeof(DE), typeof(GE)}(DE, GE, defect, global_error)
    end
end

"""
    NoErrorControl()

No error control method.
"""
struct NoErrorControl <: AbstractErrorControl end

"""
    HOErrorControl()

Higher order global error estimation method

Uses a solution from order+2 method on the original mesh and calculate the error with

```math
\\text{error} = \\max\\frac{u_p - u_{p+2}}{1 + |u_p|}
```
"""
struct HOErrorControl <: GlobalErrorControlMethod end

"""
    REErrorControl()

Richardson extrapolation global error estimation method

Use Richardson extrapolation to calculate the error on the doubled mesh with

```math
\\text{error} = \\frac{2^p}{2^p-1} ⋅ \\max\\frac{u_h - u_{h/2}}{1 + |u_h|}
```
"""
struct REErrorControl <: GlobalErrorControlMethod end

# Some utils for error control adaptivity
# If error control use both defect and global error or not
@inline __use_both_error_control(::HybridErrorControl) = true
@inline __use_both_error_control(_) = false

# Intermediate solution evaluation
@concrete struct EvalSol{C}
    u
    t
    cache::C
end

# Basic utilities for EvalSol

Base.size(e::EvalSol) = (size(e.u[1])..., length(e.u))
Base.size(e::EvalSol, i) = size(e)[i]

Base.axes(e::EvalSol) = Base.OneTo.(size(e))
Base.axes(e::EvalSol, d::Int) = Base.OneTo.(size(e)[d])

Base.getindex(e::EvalSol, args...) = Base.getindex(VectorOfArray(e.u), args...)
Base.eachindex(e::EvalSol) = Base.eachindex(e.u)

Base.first(e::EvalSol) = first(e.u)
Base.last(e::EvalSol) = last(e.u)

Base.firstindex(e::EvalSol) = 1
Base.lastindex(e::EvalSol) = length(e.u)

Base.length(e::EvalSol) = length(e.u)

Base.eltype(e::EvalSol) = eltype(e.u)

function Base.show(io::IO, m::MIME"text/plain", e::EvalSol)
    (print(io, "t: "); show(io, m, e.t); println(io); print(io, "u: "); show(io, m, e.u))
end

Base.maximum(sol::EvalSol) = maximum(Iterators.flatten(sol.u))
Base.minimum(sol::EvalSol) = minimum(Iterators.flatten(sol.u))

recursive_length(x::Vector{<:AbstractArray}) = sum(length, x)
recursive_length(x::Vector{<:DiffCache}) = sum(xᵢ -> length(xᵢ.u), x)

function recursive_flatten(x::Vector{<:AbstractArray})
    y = zero(first(x), recursive_length(x))
    recursive_flatten!(y, x)
    return y
end

@views function recursive_flatten!(y::AbstractVector, x::Vector{<:AbstractArray})
    i = 0
    for xᵢ in x
        copyto!(y[(i + 1):(i + length(xᵢ))], xᵢ)
        i += length(xᵢ)
    end
    return y
end
@views function recursive_flatten_twopoint!(y::AbstractVector, x::Vector{<:AbstractArray}, sizes)
    x_, xiter = first(x), x[2:end]
    copyto!(y[1:prod(sizes[1])], x_[1:prod(sizes[1])])
    i = prod(sizes[1])
    for xᵢ in xiter
        copyto!(y[(i + 1):(i + length(xᵢ))], xᵢ)
        i += length(xᵢ)
    end
    copyto!(y[(i + 1):(i + prod(sizes[2]))], x_[(end - prod(sizes[2]) + 1):end])
    return y
end

@views function recursive_unflatten!(y::Vector{<:AbstractArray}, x::AbstractVector)
    i = 0
    for yᵢ in y
        copyto!(yᵢ, x[(i + 1):(i + length(yᵢ))])
        i += length(yᵢ)
    end
    return y
end

@views function recursive_unflatten!(y::Vector{<:DiffCache}, x::AbstractVector)
    return recursive_unflatten!(get_tmp.(y, (x,)), x)
end

@views function recursive_unflatten!(y::AbstractVectorOfArray, x::AbstractVector)
    i = 0
    for yᵢ in y
        copyto!(yᵢ, x[(i + 1):(i + length(yᵢ))])
        i += length(yᵢ)
    end
    return y
end

function diff!(dx, x)
    for i in eachindex(dx)
        dx[i] = x[i + 1] - x[i]
    end
    return dx
end

function __maybe_matmul!(z::AbstractArray, A, b, α = eltype(z)(1), β = eltype(z)(0))
    return mul!(z, A, b, α, β)
end

# NOTE: We can implement it as mul! as above but then we pay the cost of moving
#       `w` to the GPU too many times. Instead if we iterate of w and w′ we save
#       that cost. Our main cost is anyways going to be due to a large `u0` and
#       we are going to use GPUs for that
@views function __maybe_matmul!(z, A, b, α = eltype(z)(1), β = eltype(z)(0))
    @simd ivdep for j in eachindex(b)
        @inbounds @. z = α * A[:, j] * b[j] + β * z
    end
    return z
end

"""
    interval(mesh, t)

Find the interval that `t` belongs to in `mesh`. Assumes that `mesh` is sorted.
"""
function interval(mesh, t)
    return clamp(searchsortedfirst(mesh, t) - 1, 1, length(mesh) - 1)
end

## Easier to dispatch
eval_bc_residual(pt, bc::BC, sol, p) where {BC} = eval_bc_residual(pt, bc, sol, p, sol.t)
eval_bc_residual(_, bc::BC, sol, p, t) where {BC} = bc(sol, p, t)
function eval_bc_residual(
        ::TwoPointBVProblem, (bca, bcb)::BC, sol::AbstractVectorOfArray, p, t
    ) where {BC}
    ua = sol[:, 1]
    ub = sol[:, end]
    resida = bca(__maybe_scalar_state(ua), p)
    residb = bcb(__maybe_scalar_state(ub), p)
    return (resida, residb)
end
function eval_bc_residual(
        ::TwoPointBVProblem, (bca, bcb)::BC, sol::AbstractArray, p, t
    ) where {BC}
    ua = first(sol)
    ub = last(sol)
    resida = bca(__maybe_scalar_state(ua), p)
    residb = bcb(__maybe_scalar_state(ub), p)
    return (resida, residb)
end

function eval_bc_residual!(resid, pt, bc!::BC, sol, p) where {BC}
    return eval_bc_residual!(resid, pt, bc!, sol, p, sol.t)
end
eval_bc_residual!(resid, _, bc!::BC, sol, p, t) where {BC} = bc!(resid, sol, p, t)
@views function eval_bc_residual!(
        resid, ::TwoPointBVProblem, (bca!, bcb!)::BC,
        sol::AbstractVectorOfArray, p, t
    ) where {BC}
    ua = sol.u[1]
    ub = sol.u[end]
    bca!(resid.resida, ua, p)
    bcb!(resid.residb, ub, p)
    return resid
end
@views function eval_bc_residual!(
        resid, ::TwoPointBVProblem, (bca!, bcb!)::BC, sol::AbstractArray, p, t
    ) where {BC}
    ua = first(sol)
    ub = last(sol)
    bca!(resid.resida, ua, p)
    bcb!(resid.residb, ub, p)
    return resid
end
@views function eval_bc_residual!(
        resid::Tuple, ::TwoPointBVProblem, (bca!, bcb!)::BC,
        sol::AbstractVectorOfArray, p, t
    ) where {BC}
    ua = sol.u[1]
    ub = sol.u[end]
    bca!(resid[1], ua, p)
    bcb!(resid[2], ub, p)
    return resid
end
@views function eval_bc_residual!(
        resid::Tuple, ::TwoPointBVProblem, (bca!, bcb!)::BC,
        sol::AbstractArray, p, t
    ) where {BC}
    ua = first(sol)
    ub = last(sol)
    bca!(resid[1], ua, p)
    bcb!(resid[2], ub, p)
    return resid
end
@views function eval_bc_residual!(
        resid::Tuple, ::TwoPointBVProblem, (bca!, bcb!)::BC,
        sol::SciMLBase.ODESolution, p, t
    ) where {BC}
    ua = first(sol)
    ub = last(sol)
    bca!(resid[1], ua, p)
    bcb!(resid[2], ub, p)
    return resid
end

function eval_bc_residual(::StandardSecondOrderBVProblem, bc::BC, y, dy, p, t) where {BC}
    res_bc = bc(dy, y, p, t)
    return res_bc
end
function eval_bc_residual(
        ::TwoPointSecondOrderBVProblem, (bca, bcb)::BC,
        sol::AbstractVectorOfArray, p, t
    ) where {BC}
    L = length(t)
    ua = sol[:, 1]
    ub = sol[:, L]
    dua = sol[:, L + 1]
    dub = sol[:, end]
    return vcat(bca(dua, ua, p), bcb(dub, ub, p))
end
function eval_bc_residual(
        ::TwoPointSecondOrderBVProblem, (bca, bcb)::BC, sol::AbstractArray, p, t
    ) where {BC}
    L = length(t)
    ua = first(sol)
    ub = sol[L]
    dua = sol[L + 1]
    dub = last(sol)
    return vcat(bca(dua, ua, p), bcb(dub, ub, p))
end

function eval_bc_residual!(resid, ::StandardBVProblem, bc!::BC, sol, p, t) where {BC}
    return bc!(resid, sol, p, t)
end

function eval_bc_residual!(
        resid, ::StandardSecondOrderBVProblem, bc!::BC, sol, dsol, p, t
    ) where {BC}
    return bc!(resid, dsol, sol, p, t)
end

function eval_bc_residual!(
        resid::AbstractArray{<:AbstractArray},
        ::StandardSecondOrderBVProblem, bc!::BC, sol, dsol, p, t
    ) where {BC}
    M = length(sol.u[1])
    res_bc = vcat(resid[1], resid[2])
    bc!(res_bc, dsol, sol, p, t)
    copyto!(resid[1], res_bc[1:M])
    return copyto!(resid[2], res_bc[(M + 1):end])
end

function eval_bc_residual!(
        resid, ::TwoPointSecondOrderBVProblem, (bca!, bcb!)::BC,
        sol::AbstractVectorOfArray, p, t
    ) where {BC}
    L = length(t)
    ua = sol[:, 1]
    ub = sol[:, L]
    dua = sol[:, L + 1]
    dub = sol[:, end]
    bca!(resid[1], dua, ua, p)
    return bcb!(resid[2], dub, ub, p)
end
function eval_bc_residual!(
        resid, ::TwoPointSecondOrderBVProblem,
        (bca!, bcb!)::BC, sol::AbstractArray, p, t
    ) where {BC}
    L = length(t)
    ua = first(sol)
    ub = sol[L]
    dua = sol[L + 1]
    dub = last(sol)
    bca!(resid[1], dua, ua, p)
    return bcb!(resid[2], dub, ub, p)
end

"""
    __resize!(x, n, M)

Resizes the input `x` to length `n` and returns the resized array. If `n` is less than the
length of `x`, it truncates the array. If `n` is greater than the length of `x`, it appends
zeros to the array.

!!! note

    We use `last` since the `first` might not conform to the same structure. For example, in the case of residuals
"""
function __resize!(x::AbstractVector{<:AbstractArray}, n, M)
    N = n - length(x)
    N == 0 && return x
    N > 0 ? append!(x, [zero(last(x)) for _ in 1:N]) : resize!(x, n)
    return x
end

__resize!(::Nothing, n, _) = nothing
__resize!(::Nothing, n, _, _) = nothing

function __resize!(x::AbstractVector{<:DiffCache}, n, M)
    N = n - length(x)
    N == 0 && return x
    if N > 0
        chunksize = pickchunksize(M * (N + length(x)))
        append!(x, [__maybe_allocate_diffcache(last(x), chunksize) for _ in 1:N])
    else
        resize!(x, n)
    end
    return x
end

function __resize!(x::AbstractVectorOfArray, n, M)
    N = n - length(x)
    N == 0 && return x
    N > 0 ? append!(x, VectorOfArray([safe_similar(last(x)) for _ in 1:N])) : resize!(x, n)
    return x
end

## Problem with Initial Guess
function __extract_problem_details(prob; kwargs...)
    return __extract_problem_details(prob, prob.u0; kwargs...)
end
function __extract_problem_details(prob, u0::Number; dt = 0.0, check_positive_dt::Bool = false, kwargs...)
    # Scalar BVP
    check_positive_dt && dt ≤ 0 && throw(ArgumentError("dt must be positive"))
    t₀, t₁ = prob.tspan
    return Val(true), typeof(u0), 1, Int(cld(t₁ - t₀, dt)), [u0]
end
function __extract_problem_details(prob, u0::AbstractVector{<:AbstractArray}; kwargs...)
    # Problem has Initial Guess
    _u0 = first(u0)
    return Val(true), eltype(_u0), length(_u0), (length(u0) - 1), _u0
end
function __extract_problem_details(prob, u0::AbstractVectorOfArray; kwargs...)
    # Problem has Initial Guess
    _u0 = first(u0.u)
    return Val(true), eltype(_u0), length(_u0), (length(u0.u) - 1), _u0
end
function __extract_problem_details(
        prob, u0::AbstractArray; dt = 0.0,
        check_positive_dt::Bool = false, tune_parameters::Bool = false
    )
    # Problem does not have Initial Guess
    check_positive_dt && dt ≤ 0 && throw(ArgumentError("dt must be positive"))
    t₀, t₁ = prob.tspan
    if tune_parameters
        prob.p isa SciMLBase.NullParameters &&
            throw(ArgumentError("`tune_parameters` is true but `prob.p` is not set."))
        new_u = vcat(u0, __tunable_part(prob.p))
        return Val(false), eltype(new_u), length(new_u), Int(cld(t₁ - t₀, dt)), new_u
    end
    return Val(false), eltype(u0), length(u0), Int(cld(t₁ - t₀, dt)), prob.u0
end
function __extract_problem_details(
        prob, f::F; dt = 0.0, check_positive_dt::Bool = false,
        tune_parameters::Bool = false
    ) where {F <: Function}
    # Problem passes in a initial guess function
    check_positive_dt && dt ≤ 0 && throw(ArgumentError("dt must be positive"))

    u0 = __initial_guess(f, prob.p, prob.tspan[1]; tune_parameters = tune_parameters)
    t₀, t₁ = prob.tspan
    return Val(true), eltype(u0), length(u0), Int(cld(t₁ - t₀, dt)), u0
end

function __extract_problem_details(
        prob, u0::SciMLBase.ODESolution; dt = 0.0,
        check_positive_dt::Bool = false, tune_parameters::Bool = false
    )
    # Problem passes in a initial guess function
    _u0 = first(u0.u)
    _t = u0.t
    if tune_parameters
        new_u = vcat(_u0, __tunable_part(prob.p))
        return Val(false), eltype(new_u), length(new_u), Int(cld(t₁ - t₀, dt)), new_u
    end
    return Val(true), eltype(_u0), length(_u0), (length(_t) - 1), _u0
end

function __initial_guess(f::F, p::P, t::T; tune_parameters = false) where {F, P, T}
    if hasmethod(f, Tuple{P, T})
        tune_parameters && return vcat(f(p, t), __tunable_part(p))
        return f(p, t)
    elseif hasmethod(f, Tuple{T})
        Base.depwarn(
            "initial guess function must take 2 inputs `(p, t)` instead of just \
                     `t`. The single argument version has been deprecated and will be \
                     removed in the next major release of SciMLBase.",
            :__initial_guess
        )
        tune_parameters && return vcat(f(t), __tunable_part(p))
        return f(t)
    else
        throw(ArgumentError("`initial_guess` must be a function of the form `f(p, t)`"))
    end
end

function __tunable_part(p)
    if SciMLStructures.isscimlstructure(p)
        part, _ = SciMLStructures.canonicalize(SciMLStructures.Tunable(), p)
        return part
    else
        p
    end
end

function __get_bcresid_prototype(prob::BVProblem, u)
    return __get_bcresid_prototype(prob.problem_type, prob, u)
end
function __get_bcresid_prototype(::TwoPointBVProblem, prob::BVProblem, u)
    prototype = if prob.f.bcresid_prototype !== nothing
        prob.f.bcresid_prototype.x
    else
        u₀ = __maybe_scalar_state(u)
        first(prob.f.bc)(u₀, prob.p), last(prob.f.bc)(u₀, prob.p)
    end
    return prototype, size.(prototype)
end
function __get_bcresid_prototype(::StandardBVProblem, prob::BVProblem, u)
    prototype = prob.f.bcresid_prototype !== nothing ? prob.f.bcresid_prototype : zero(u)
    return prototype, size(prototype)
end

function __get_bcresid_prototype(::TwoPointSecondOrderBVProblem, prob::BVProblem, u)
    prototype = if prob.f.bcresid_prototype !== nothing
        prob.f.bcresid_prototype.x
    else
        first(prob.f.bc)(u, prob.p), last(prob.f.bc)(u, prob.p)
    end
    return prototype, size.(prototype)
end
function __get_bcresid_prototype(::StandardSecondOrderBVProblem, prob::BVProblem, u)
    prototype = prob.f.bcresid_prototype !== nothing ? prob.f.bcresid_prototype :
        __zeros_like(u)
    return prototype, size(prototype)
end

@inline function safe_similar(x::AbstractArray{<:T}, args...) where {T <: Number}
    y = similar(x, args...)
    fill!(y, T(0))
    return y
end

@inline function __fill_like(v, x, args...)
    y = similar(x, args...)
    fill!(y, v)
    return y
end

@inline __ones_like(args...) = __fill_like(1, args...)
@inline __zeros_like(args...) = __fill_like(0, args...)

@inline __safe_vec(x) = vec(x)
@inline __safe_vec(x::Tuple) = mapreduce(__safe_vec, vcat, x)

@inline __vec(x::Number) = [x]
@inline __vec(x::AbstractArray) = vec(x)
@inline __vec(x::Tuple) = mapreduce(__vec, vcat, x)

@inline __maybe_scalar_state(x::Number) = x
@inline function __maybe_scalar_state(x::AbstractArray)
    return length(x) == 1 ? first(x) : x
end
@inline function __maybe_scalar_state(x::Tuple)
    return length(x) == 1 ? first(x) : x
end
@inline __maybe_scalar_state(x) = x

# Restructure Non-Vector Inputs
function __vec_f!(du, u, p, t, f!, u_size)
    f!(reshape(du, u_size), reshape(u, u_size), p, t)
    return nothing
end

__vec_f(u, p, t, f, u_size) = vec(f(reshape(u, u_size), p, t))

function __vec_bc!(resid, sol, p, t, bc!, resid_size, u_size)
    bc!(reshape(resid, resid_size), sol, p, t)
    return nothing
end

function __vec_bc!(resid, sol, p, bc!, resid_size, u_size)
    bc!(reshape(resid, resid_size), reshape(sol, u_size), p)
    return nothing
end

__vec_bc(sol, p, t, bc, u_size) = vec(bc(sol, p, t))
__vec_bc(sol, p, bc, u_size) = vec(bc(reshape(sol, u_size), p))

# Restructure Non-Vector Inputs
function __vec_f!(ddu, du, u, p, t, f!, u_size)
    f!(reshape(ddu, u_size), reshape(du, u_size), reshape(u, u_size), p, t)
    return nothing
end

__vec_f(du, u, p, t, f, u_size) = vec(f(reshape(du, u_size), reshape(u, u_size), p, t))

function __vec_so_bc!(resid, dsol, sol, p, t, bc!, resid_size, u_size)
    bc!(
        reshape(resid, resid_size), __restructure_sol(dsol, u_size),
        __restructure_sol(sol, u_size), p, t
    )
    return nothing
end

function __vec_so_bc!(resid, dsol, sol, p, bc!, resid_size, u_size)
    bc!(reshape(resid, resid_size), reshape(dsol, u_size), reshape(sol, u_size), p)
    return nothing
end

function __vec_so_bc(dsol, sol, p, t, bc, u_size)
    return vec(bc(__restructure_sol(dsol, u_size), __restructure_sol(sol, u_size), p, t))
end
function __vec_so_bc(dsol, sol, p, bc, u_size)
    return vec(bc(reshape(dsol, u_size), reshape(sol, u_size), p))
end

@inline __get_non_sparse_ad(ad::AbstractADType) = ad
@inline __get_non_sparse_ad(ad::AutoSparse) = ADTypes.dense_ad(ad)

# Restructure Solution
function __restructure_sol(sol::AbstractVectorOfArray, u_size)
    (size(first(sol.u)) == u_size) && return sol
    return VectorOfArray(map(Base.Fix2(reshape, u_size), sol.u))
end
function __restructure_sol(sol::AbstractArray{<:AbstractArray}, u_size)
    (size(first(sol)) == u_size) && return sol
    return map(Base.Fix2(reshape, u_size), sol)
end

# Construct the internal NonlinearProblem
@inline function __internal_nlsolve_problem(
        ::BVProblem{uType, tType, iip, nlls}, resid_prototype,
        u0, args...; kwargs...
    ) where {uType, tType, iip, nlls}
    if nlls
        return NonlinearLeastSquaresProblem(args...; kwargs...)
    else
        return NonlinearProblem(args...; kwargs...)
    end
end

@inline function __internal_nlsolve_problem(
        bvp::BVProblem{uType, tType, iip, Nothing}, resid_prototype,
        u0, args...; kwargs...
    ) where {uType, tType, iip}
    return __internal_nlsolve_problem(
        bvp, length(resid_prototype), length(u0), args...; kwargs...
    )
end

@inline function __internal_nlsolve_problem(
        ::BVProblem{uType, tType, iip, Nothing}, l1::Int,
        l2::Int, args...; kwargs...
    ) where {uType, tType, iip}
    if l1 != l2
        return NonlinearLeastSquaresProblem(args...; kwargs...)
    else
        return NonlinearProblem(args...; kwargs...)
    end
end

@inline function __internal_nlsolve_problem(
        ::SecondOrderBVProblem{uType, tType, iip, nlls}, resid_prototype,
        u0, args...; kwargs...
    ) where {uType, tType, iip, nlls}
    return NonlinearProblem(args...; kwargs...)
end

# Construct the internal OptimizationProblem
@inline function __internal_optimization_problem(
        ::BVProblem{uType, tType, iip}, args...; kwargs...
    ) where {uType, tType, iip}
    prob = OptimizationProblem(args...; kwargs...)
    return prob
end

@inline function __internal_optimization_problem(
        ::SecondOrderBVProblem{uType, tType, iip},
        args...; kwargs...
    ) where {uType, tType, iip}
    prob = OptimizationProblem(args...; kwargs...)
    return prob
end

# Handling Initial Guesses
"""
    __extract_u0(u₀, t₀)

Takes the input initial guess and returns the value at the starting mesh point.
"""
@inline __extract_u0(u₀::AbstractVector{<:AbstractArray}, p, t₀) = u₀[1]
@inline __extract_u0(u₀::VectorOfArray, p, t₀) = u₀[:, 1]
@inline __extract_u0(u₀::DiffEqArray, p, t₀) = u₀.u[1]
@inline __extract_u0(u₀::F, p, t₀) where {F <: Function} = __initial_guess(u₀, p, t₀)
@inline __extract_u0(u₀::AbstractArray, p, t₀) = u₀
@inline __extract_u0(u₀::SciMLBase.ODESolution, p, t₀) = u₀.u[1]
@inline __extract_u0(u₀::Number, p, t₀) = u₀
@inline __extract_u0(u₀::T, p, t₀) where {T} = error("`prob.u0::$(T)` is not supported.")

"""
    __extract_mesh(u₀, t₀, t₁, n)

Takes the input initial guess and returns the mesh.
"""
@inline __extract_mesh(u₀, t₀, t₁, n::Int) = collect(range(t₀; stop = t₁, length = n + 1))
@inline function __extract_mesh(u₀, t₀, t₁, dt::Number)
    # Use range with specified endpoints to ensure mesh includes exactly t₀ and t₁
    # This fixes issues where t₀:dt:t₁ may not include t₁ due to floating point precision
    n = Int(cld(t₁ - t₀, dt))
    return collect(range(t₀; stop = t₁, length = n + 1))
end
@inline __extract_mesh(u₀::DiffEqArray, t₀, t₁, ::Int) = copy(u₀.t)
@inline __extract_mesh(u₀::DiffEqArray, t₀, t₁, ::Number) = copy(u₀.t)
@inline __extract_mesh(u₀::SciMLBase.ODESolution, t₀, t₁, ::Int) = copy(u₀.t)
@inline __extract_mesh(u₀::SciMLBase.ODESolution, t₀, t₁, ::Number) = copy(u₀.t)

"""
    __has_initial_guess(u₀) -> Bool

Returns `true` if the input has an initial guess.
"""
@inline __has_initial_guess(u₀::AbstractVector{<:AbstractArray}) = true
@inline __has_initial_guess(u₀::VectorOfArray) = true
@inline __has_initial_guess(u₀::DiffEqArray) = true
@inline __has_initial_guess(u₀::SciMLBase.ODESolution) = true
@inline __has_initial_guess(u₀::F) where {F} = true
@inline __has_initial_guess(u₀::AbstractArray) = false

"""
    __initial_guess_length(u₀) -> Int

Returns the length of the initial guess. If the initial guess is a function or no initial
guess is supplied, it returns `-1`.
"""
@inline __initial_guess_length(u₀::AbstractVector{<:AbstractArray}) = length(u₀)
@inline __initial_guess_length(u₀::VectorOfArray) = length(u₀.u)
@inline __initial_guess_length(u₀::DiffEqArray) = length(u₀.t)
@inline __initial_guess_length(u₀::SciMLBase.ODESolution) = length(u₀.t)
@inline __initial_guess_length(u₀::F) where {F} = -1
@inline __initial_guess_length(u₀::AbstractArray) = -1

"""
    __flatten_initial_guess(u₀) -> Union{AbstractMatrix, AbstractVector, Nothing}

Flattens the initial guess into a matrix. For a function `u₀`, it returns `nothing`. For no
initial guess, it returns `vec(u₀)`.
"""
@inline __flatten_initial_guess(u₀::AbstractVector{<:AbstractArray}) = mapreduce(vec, hcat, u₀)
@inline __flatten_initial_guess(u₀::VectorOfArray) = mapreduce(vec, hcat, u₀.u)
@inline __flatten_initial_guess(u₀::DiffEqArray) = mapreduce(vec, hcat, u₀.u)
@inline __flatten_initial_guess(u₀::SciMLBase.ODESolution) = mapreduce(vec, hcat, u₀.u)
@inline __flatten_initial_guess(u₀::AbstractArray) = vec(u₀)
@inline __flatten_initial_guess(u₀::F) where {F} = nothing

"""
    __initial_guess_on_mesh(u₀, mesh, p, alias_u0::Bool)

Returns the initial guess on the mesh. For `DiffEqArray` assumes that the mesh is the same
as the mesh of the `DiffEqArray`.
"""
@inline function __initial_guess_on_mesh(u₀::AbstractVector{<:AbstractArray}, mesh, p; tune_parameters = false)
    tune_parameters && return VectorOfArray([vcat(vec(u), __tunable_part(p)) for u in u₀])
    return VectorOfArray([copy(vec(u)) for u in u₀])
end
@inline function __initial_guess_on_mesh(u₀::VectorOfArray, mesh, p; tune_parameters = false)
    tune_parameters && return VectorOfArray([vcat(vec(u), __tunable_part(p)) for u in u₀.u])
    return copy(u₀)
end
@inline function __initial_guess_on_mesh(u₀::DiffEqArray, mesh, p; tune_parameters = false)
    tune_parameters && return DiffEqArray([vcat(vec(u), __tunable_part(p)) for u in u₀.u])
    return copy(u₀)
end
@inline function __initial_guess_on_mesh(u₀::SciMLBase.ODESolution, mesh, p; tune_parameters = false)
    tune_parameters && return VectorOfArray([vcat(vec(u), __tunable_part(p)) for u in u₀.u])
    return copy(VectorOfArray(u₀.u))
end
@inline function __initial_guess_on_mesh(u₀::AbstractArray, mesh, p; tune_parameters = false)
    tune_parameters && return VectorOfArray([vcat(vec(u₀), __tunable_part(p)) for _ in mesh])
    return VectorOfArray([copy(vec(u₀)) for _ in mesh])
end
@inline function __initial_guess_on_mesh(u₀::F, mesh, p; tune_parameters = false) where {F}
    tune_parameters && return VectorOfArray([vcat(vec(__initial_guess(u₀, p, t)), __tunable_part(p)) for t in mesh])
    return VectorOfArray([vec(__initial_guess(u₀, p, t)) for t in mesh])
end
@inline function __initial_guess_on_mesh(u₀::Number, mesh, p; tune_parameters = false)
    tune_parameters && return VectorOfArray([vcat([u₀], __tunable_part(p)) for _ in mesh])
    return VectorOfArray([copy([u₀]) for _ in mesh])
end
@inline function __initial_guess_on_mesh(prob::SecondOrderBVProblem, u₀::AbstractArray, Nig, p)
    return VectorOfArray([copy(vec(u₀)) for _ in 1:(2 * (Nig + 1))])
end
@inline function __initial_guess_on_mesh(prob::SecondOrderBVProblem, u₀::AbstractVector{<:AbstractVector}, _, p)
    return VectorOfArray(vcat([copy(vec(u)) for u in u₀], [copy(vec(u)) for u in u₀]))
end
@inline function __initial_guess_on_mesh(prob::SecondOrderBVProblem, u₀::VectorOfArray, _, p)
    return VectorOfArray(vcat(copy(u₀.u), copy(u₀.u)))
end
@inline function __initial_guess_on_mesh(prob::SecondOrderBVProblem, u₀::SciMLBase.ODESolution, Nig, p)
    return VectorOfArray(vcat(copy(VectorOfArray(u₀.u)), copy(VectorOfArray(u₀.u))))
end

# Construct BVP Solution
function __build_solution(prob::AbstractBVProblem, odesol, nlsol::SciMLBase.NonlinearSolution)
    retcode = ifelse(SciMLBase.successful_retcode(nlsol), odesol.retcode, nlsol.retcode)
    return SciMLBase.solution_new_original_retcode(odesol, nlsol, retcode, nlsol.resid)
end
function __build_solution(prob::AbstractBVProblem, odesol, optsol::SciMLBase.OptimizationSolution)
    retcode = ifelse(SciMLBase.successful_retcode(optsol), odesol.retcode, optsol.retcode)
    return SciMLBase.solution_new_original_retcode(odesol, optsol, retcode, zeros(length(first(odesol)))) # Need a patch in SciMLBase
end

# Fix3
@concrete struct __Fix3
    f
    x
end

@inline (f::__Fix3{F})(a, b) where {F} = f.f(a, b, f.x)

get_dense_ad(::Nothing) = nothing
get_dense_ad(ad) = ad
get_dense_ad(ad::AutoSparse) = ADTypes.dense_ad(ad)

# traits for forward or reverse mode AutoForwardDiff

function _sparse_like(I, J, x::AbstractArray, m = maximum(I), n = maximum(J))
    I′ = adapt(parameterless_type(x), I)
    J′ = adapt(parameterless_type(x), J)
    V = __ones_like(x, length(I))
    return sparse(I′, J′, V, m, n)
end

nodual_value(x) = x
nodual_value(x::ForwardDiff.Dual) = ForwardDiff.value(x)
nodual_value(x::AbstractArray{<:ForwardDiff.Dual}) = map(ForwardDiff.value, x)
nodual_value(x::SparseConnectivityTracer.Dual) = SparseConnectivityTracer.primal(x)
function nodual_value(x::AbstractArray{<:SparseConnectivityTracer.Dual})
    return map(SparseConnectivityTracer.primal, x)
end

function __split_kwargs(; abstol, adaptive, controller, verbose = DEFAULT_VERBOSE, kwargs...)
    return ((abstol, adaptive, controller, verbose), (; abstol, adaptive, kwargs...))
end

@inline __concrete_kwargs(nlsolve, ::Nothing, nlsolve_kwargs, optimize_kwargs) = (;
    nlsolve_kwargs...,
)
@inline __concrete_kwargs(::Nothing, optimize, nlsolve_kwargs, optimize_kwargs) = (;) # Doesn't support for now
@inline __concrete_kwargs(::Nothing, ::Nothing, nlsolve_kwargs, optimize_kwargs) = (;
    nlsolve_kwargs...,
)

# Overloads that handle BVP verbosity → NonlinearSolve verbosity conversion
@inline function __concrete_kwargs(
        nlsolve, ::Nothing, nlsolve_kwargs, optimize_kwargs, bvp_verbose::BVPVerbosity
    )
    # Check if user already specified verbose in nlsolve_kwargs
    if haskey(nlsolve_kwargs, :verbose)
        return (; nlsolve_kwargs...)  # User's explicit verbose wins
    else
        # Convert preset to NonlinearVerbosity if needed
        nl_verbose = bvp_verbose.nonlinear_verbosity isa NonlinearVerbosity ?
            bvp_verbose.nonlinear_verbosity :
            NonlinearVerbosity(bvp_verbose.nonlinear_verbosity)
        return (; verbose = nl_verbose, nlsolve_kwargs...)
    end
end

@inline function __concrete_kwargs(
        ::Nothing, ::Nothing, nlsolve_kwargs, optimize_kwargs, bvp_verbose::BVPVerbosity
    )
    if haskey(nlsolve_kwargs, :verbose)
        return (; nlsolve_kwargs...)
    else
        # Convert preset to NonlinearVerbosity if needed
        nl_verbose = bvp_verbose.nonlinear_verbosity isa NonlinearVerbosity ?
            bvp_verbose.nonlinear_verbosity :
            NonlinearVerbosity(bvp_verbose.nonlinear_verbosity)
        return (; verbose = nl_verbose, nlsolve_kwargs...)
    end
end

@inline function __concrete_kwargs(
        ::Nothing, optimize, nlsolve_kwargs, optimize_kwargs, bvp_verbose::BVPVerbosity
    )
    # Check if user already specified verbose in optimize_kwargs
    if haskey(optimize_kwargs, :verbose)
        return (; optimize_kwargs...)  # User's explicit verbose wins
    else
        # Convert preset to OptimizationVerbosity if needed
        opt_verbose = bvp_verbose.optimization_verbosity isa OptimizationVerbosity ?
            bvp_verbose.optimization_verbosity :
            OptimizationVerbosity(bvp_verbose.optimization_verbosity)
        return (; verbose = opt_verbose, optimize_kwargs...)
    end
end

"""
    __add_singular_term!(K, singular_term, y, t)

Helper function to add the singular term contribution S * y / t to K for t > 0.
Used in collocation residual computation for singular BVPs of the form y' = S*y/t + f(t,y).
"""
@inline function __add_singular_term!(K, singular_term::Nothing, y, t)
    return nothing
end

@inline function __add_singular_term!(K, singular_term::AbstractMatrix, y, t)
    if t > 0
        mul!(K, singular_term, y, one(t) / t, one(t))
    end
    return nothing
end

@verbosity_specifier BVPVerbosity begin
    toggles = (
        :nonlinear_verbosity,
        :optimization_verbosity,
        :bvpsol_convergence,
        :bvpsol_integrator,
        :bvpsol_linear_solver,
        :bvpsol_resources,
        :bvpsol_bc_inconsistent,
        :colnew_convergence,
        :colnew_matrix,
        :colnew_resources,
        :colnew_input,
        :shooting_initial_guess,
        :multiple_shooting_initial_guess,
        :type_inference,
        :initialization,
        :adaptivity,
        :convergence_result,
        :deprecations,
    )

    presets = (
        None = (
            nonlinear_verbosity = None(),
            optimization_verbosity = None(),
            bvpsol_convergence = Silent(),
            bvpsol_integrator = Silent(),
            bvpsol_linear_solver = Silent(),
            bvpsol_resources = Silent(),
            bvpsol_bc_inconsistent = Silent(),
            colnew_convergence = Silent(),
            colnew_matrix = Silent(),
            colnew_resources = Silent(),
            colnew_input = Silent(),
            shooting_initial_guess = Silent(),
            multiple_shooting_initial_guess = Silent(),
            type_inference = Silent(),
            initialization = Silent(),
            adaptivity = Silent(),
            convergence_result = Silent(),
            deprecations = Silent(),
        ),
        Minimal = (
            nonlinear_verbosity = Minimal(),
            optimization_verbosity = Minimal(),
            bvpsol_convergence = WarnLevel(),
            bvpsol_integrator = WarnLevel(),
            bvpsol_linear_solver = WarnLevel(),
            bvpsol_resources = WarnLevel(),
            bvpsol_bc_inconsistent = WarnLevel(),
            colnew_convergence = WarnLevel(),
            colnew_matrix = WarnLevel(),
            colnew_resources = WarnLevel(),
            colnew_input = WarnLevel(),
            shooting_initial_guess = Silent(),
            multiple_shooting_initial_guess = Silent(),
            type_inference = Silent(),
            initialization = Silent(),
            adaptivity = Silent(),
            convergence_result = Silent(),
            deprecations = WarnLevel(),
        ),
        Standard = (
            nonlinear_verbosity = Standard(),
            optimization_verbosity = Standard(),
            bvpsol_convergence = WarnLevel(),
            bvpsol_integrator = WarnLevel(),
            bvpsol_linear_solver = WarnLevel(),
            bvpsol_resources = WarnLevel(),
            bvpsol_bc_inconsistent = WarnLevel(),
            colnew_convergence = WarnLevel(),
            colnew_matrix = WarnLevel(),
            colnew_resources = WarnLevel(),
            colnew_input = WarnLevel(),
            shooting_initial_guess = WarnLevel(),
            multiple_shooting_initial_guess = WarnLevel(),
            type_inference = WarnLevel(),
            initialization = Silent(),
            adaptivity = Silent(),
            convergence_result = Silent(),
            deprecations = WarnLevel(),
        ),
        Detailed = (
            nonlinear_verbosity = Detailed(),
            optimization_verbosity = Detailed(),
            bvpsol_convergence = WarnLevel(),
            bvpsol_integrator = WarnLevel(),
            bvpsol_linear_solver = WarnLevel(),
            bvpsol_resources = WarnLevel(),
            bvpsol_bc_inconsistent = WarnLevel(),
            colnew_convergence = WarnLevel(),
            colnew_matrix = WarnLevel(),
            colnew_resources = WarnLevel(),
            colnew_input = WarnLevel(),
            shooting_initial_guess = WarnLevel(),
            multiple_shooting_initial_guess = WarnLevel(),
            type_inference = WarnLevel(),
            initialization = InfoLevel(),
            adaptivity = Silent(),
            convergence_result = InfoLevel(),
            deprecations = WarnLevel(),
        ),
        All = (
            nonlinear_verbosity = All(),
            optimization_verbosity = All(),
            bvpsol_convergence = InfoLevel(),
            bvpsol_integrator = InfoLevel(),
            bvpsol_linear_solver = InfoLevel(),
            bvpsol_resources = InfoLevel(),
            bvpsol_bc_inconsistent = InfoLevel(),
            colnew_convergence = InfoLevel(),
            colnew_matrix = InfoLevel(),
            colnew_resources = InfoLevel(),
            colnew_input = InfoLevel(),
            shooting_initial_guess = InfoLevel(),
            multiple_shooting_initial_guess = InfoLevel(),
            type_inference = InfoLevel(),
            initialization = InfoLevel(),
            adaptivity = InfoLevel(),
            convergence_result = InfoLevel(),
            deprecations = WarnLevel(),
        ),
    )

    groups = (
        bvpsol = (
            :bvpsol_convergence, :bvpsol_integrator, :bvpsol_linear_solver,
            :bvpsol_resources, :bvpsol_bc_inconsistent,
        ),
        colnew = (:colnew_convergence, :colnew_matrix, :colnew_resources, :colnew_input),
        shooting = (:shooting_initial_guess, :multiple_shooting_initial_guess),
        convergence = (:bvpsol_convergence, :colnew_convergence),
        linear_algebra = (:bvpsol_linear_solver, :colnew_matrix),
        resources = (:bvpsol_resources, :colnew_resources),
        input_validation = (
            :bvpsol_bc_inconsistent, :colnew_input, :shooting_initial_guess,
            :multiple_shooting_initial_guess, :type_inference,
        ),
        solver_failures = (
            :bvpsol_convergence, :bvpsol_integrator, :bvpsol_linear_solver,
            :bvpsol_resources, :bvpsol_bc_inconsistent, :colnew_convergence,
            :colnew_matrix, :colnew_resources, :colnew_input,
        ),
        progress = (:initialization, :adaptivity, :convergence_result),
    )
end

"""
    BVPVerbosity

Verbosity specifier for controlling logging output in BoundaryValueDiffEq.jl.

# Toggles

Fine-grained toggles for specific message categories:

**BVPSOL Solver:**
- `:bvpsol_convergence` - Convergence failures (Gauss Newton, iterative refinement)
- `:bvpsol_integrator` - Integrator trajectory failures
- `:bvpsol_linear_solver` - Linear solver failures (sparse solver, condensing algorithm, rank reduction)
- `:bvpsol_resources` - Resource exhaustion (workspace limits)
- `:bvpsol_bc_inconsistent` - Boundary condition inconsistencies

**COLNEW Solver:**
- `:colnew_convergence` - Nonlinear iteration convergence failures
- `:colnew_matrix` - Collocation matrix singularity
- `:colnew_resources` - Subinterval storage exhaustion
- `:colnew_input` - Input data errors

**Shooting Methods:**
- `:shooting_initial_guess` - Single shooting initial guess warnings
- `:multiple_shooting_initial_guess` - Multiple shooting initial guess warnings

**General:**
- `:nonlinear_verbosity` - Controls verbosity of the underlying NonlinearSolve.jl solver (uses SciMLLogging presets)
- `:optimization_verbosity` - Controls verbosity of the underlying Optimization.jl solver (uses SciMLLogging presets)
- `:type_inference` - Type stability warnings
- `:initialization` - ODE solver initialization failures
- `:adaptivity` - Mesh refinement and adaptivity messages
- `:convergence_result` - Final solve status with residuals
- `:deprecations` - Deprecation warnings

# Presets

BVPVerbosity supports five predefined SciMLLogging presets:

- **None()** - No output (best for production/batch operations)
- **Minimal()** - Only solver failures and deprecations
- **Standard()** - Adds input validation warnings (default, recommended)
- **Detailed()** - Adds initialization and convergence info
- **All()** - Maximum verbosity (includes mesh adaptivity)

# Usage

## Using Presets

```julia
# Standard preset (default)
solve(prob, MIRK4(); verbose = BVPVerbosity())
solve(prob, MIRK4(); verbose = BVPVerbosity(Standard()))

# Completely silent
solve(prob, MIRK4(); verbose = BVPVerbosity(None()))

# Only solver failures
solve(prob, MIRK4(); verbose = BVPVerbosity(Minimal()))

# Detailed debugging
solve(prob, MIRK4(); verbose = BVPVerbosity(Detailed()))

# Maximum verbosity
solve(prob, MIRK4(); verbose = BVPVerbosity(All()))
```

## Setting Individual Toggles

```julia
# Show only BVPSOL convergence issues
solve(prob, BVPSOL(); verbose = BVPVerbosity(
    bvpsol_convergence = WarnLevel(),
    # All others default to Silent in None preset
))

# Silence initial guess warnings but keep solver failures
solve(prob, MultipleShooting(10); verbose = BVPVerbosity(
    Standard(),
    multiple_shooting_initial_guess = Silent()
))

# Only show linear algebra issues
solve(prob, BVPSOL(); verbose = BVPVerbosity(
    None(),
    bvpsol_linear_solver = WarnLevel(),
    colnew_matrix = WarnLevel()
))

# Control NonlinearSolve verbosity independently
solve(prob, MIRK4(); verbose = BVPVerbosity(
    None(),  # Silence BVP messages
    nonlinear_verbosity = All()  # Show all NonlinearSolve convergence info
))

# Silence NonlinearSolve but keep BVP messages
solve(prob, MIRK4(); verbose = BVPVerbosity(
    Standard(),  # Standard BVP messages
    nonlinear_verbosity = None()  # No NonlinearSolve output
))

# Control Optimization.jl verbosity independently
solve(prob, MIRK4(optimize = NLopt.LN_NELDERMEAD()); verbose = BVPVerbosity(
    None(),  # Silence BVP messages
    optimization_verbosity = All()  # Show all Optimization.jl convergence info
))
```

## Using Groups

Groups provide convenient access to related toggles:

```julia
# All BVPSOL messages
solve(prob, BVPSOL(); verbose = BVPVerbosity(bvpsol = WarnLevel()))

# All COLNEW messages
solve(prob, COLNEW(); verbose = BVPVerbosity(colnew = WarnLevel()))

# All shooting method warnings
solve(prob, Shooting(); verbose = BVPVerbosity(shooting = WarnLevel()))

# All convergence-related failures
solve(prob, alg; verbose = BVPVerbosity(convergence = WarnLevel()))

# All linear algebra issues
solve(prob, alg; verbose = BVPVerbosity(linear_algebra = WarnLevel()))

# All resource exhaustion issues
solve(prob, alg; verbose = BVPVerbosity(resources = WarnLevel()))

# All input validation warnings
solve(prob, alg; verbose = BVPVerbosity(input_validation = WarnLevel()))

# All solver failures (equivalent to Minimal preset failures)
solve(prob, alg; verbose = BVPVerbosity(solver_failures = WarnLevel()))
```

## Backward Compatibility

```julia
# Boolean verbose still works (true → Standard, false → None)
solve(prob, MIRK4(); verbose = true)   # Uses Standard preset
solve(prob, MIRK4(); verbose = false)  # Uses None preset
```

# Groups

Groups for convenient toggle control:

- **`bvpsol`** - All BVPSOL toggles
- **`colnew`** - All COLNEW toggles
- **`shooting`** - All shooting method toggles
- **`convergence`** - Convergence failures across solvers
- **`linear_algebra`** - Linear algebra failures
- **`resources`** - Resource exhaustion issues
- **`input_validation`** - Input validation warnings
- **`solver_failures`** - All solver failure toggles
- **`progress`** - Initialization, adaptivity, and convergence results

# Preset Details

## None
- `nonlinear_verbosity` → `None()` (no NonlinearSolve output)
- `optimization_verbosity` → `None()` (no Optimization.jl output)
- All toggles: `Silent()`

## Minimal
- `nonlinear_verbosity` → `Minimal()` (minimal NonlinearSolve output)
- `optimization_verbosity` → `Minimal()` (minimal Optimization.jl output)
- All solver failure toggles → `WarnLevel()`
- `deprecations` → `WarnLevel()`
- All others → `Silent()`

## Standard (Default)
- `nonlinear_verbosity` → `Standard()` (standard NonlinearSolve output)
- `optimization_verbosity` → `Standard()` (standard Optimization.jl output)
- All solver failure toggles → `WarnLevel()`
- All shooting and input validation toggles → `WarnLevel()`
- All others → `Silent()`

## Detailed
- `nonlinear_verbosity` → `Detailed()` (detailed NonlinearSolve convergence info)
- `optimization_verbosity` → `Detailed()` (detailed Optimization.jl convergence info)
- All solver failure toggles → `WarnLevel()`
- All shooting and input validation toggles → `WarnLevel()`
- `initialization` → `InfoLevel()`
- `convergence_result` → `InfoLevel()`
- `adaptivity` → `Silent()` (still off, can be very verbose)

## All
- `nonlinear_verbosity` → `All()` (maximum NonlinearSolve verbosity)
- `optimization_verbosity` → `All()` (maximum Optimization.jl verbosity)
- All toggles → `InfoLevel()` (including adaptivity)
- `deprecations` → `WarnLevel()`
"""
function BVPVerbosity end

const DEFAULT_VERBOSE = BVPVerbosity()

@inline function _process_verbose_param(verbose::SciMLLogging.AbstractVerbosityPreset)
    return BVPVerbosity(verbose)
end

@inline function _process_verbose_param(verbose::Bool)
    return verbose ? DEFAULT_VERBOSE : BVPVerbosity(SciMLLogging.None())
end

@inline _process_verbose_param(verbose::BVPVerbosity) = verbose

# A foreign AbstractVerbositySpecifier (e.g. DiffEqBase.DEVerbosity) can flow in
# through DiffEqBase's `solve`/`init` default kwargs (`verbose = DEFAULT_VERBOSE`,
# which is a `DEVerbosity`). BVPVerbosity's toggles differ from DEVerbosity's, so
# we cannot meaningfully translate it; fall back to BVP's own default rather than
# dispatch-missing at precompile time.
@inline _process_verbose_param(::SciMLLogging.AbstractVerbositySpecifier) = DEFAULT_VERBOSE

# Sparsity Detection
@concrete struct BVPJacobianAlgorithm
    bc_diffmode
    nonbc_diffmode
    diffmode
end

@inline __materialize_jacobian_algorithm(_, alg::BVPJacobianAlgorithm) = alg
@inline __materialize_jacobian_algorithm(_, alg::ADTypes.AbstractADType) = BVPJacobianAlgorithm(alg)
@inline __materialize_jacobian_algorithm(::Nothing, ::Nothing) = BVPJacobianAlgorithm()
@inline function __materialize_jacobian_algorithm(nlsolve::N, ::Nothing) where {N}
    ad = hasfield(N, :jacobian_ad) ? nlsolve.jacobian_ad : missing
    return BVPJacobianAlgorithm(ad)
end

function Base.show(io::IO, alg::BVPJacobianAlgorithm)
    print(io, "BVPJacobianAlgorithm(")
    modifiers = String[]
    if alg.diffmode !== nothing && alg.diffmode !== missing
        push!(modifiers, "diffmode = $(__nameof(alg.diffmode))()")
    else
        if alg.nonbc_diffmode !== missing && alg.nonbc_diffmode !== nothing
            push!(modifiers, "nonbc_diffmode = $(__nameof(alg.nonbc_diffmode))()")
        end
        if alg.bc_diffmode !== missing && alg.bc_diffmode !== nothing
            push!(modifiers, "bc_diffmode = $(__nameof(alg.bc_diffmode))()")
        end
    end
    print(io, join(modifiers, ", "))
    return print(io, ")")
end

@inline __any_sparse_ad(::AutoSparse) = true
@inline function __any_sparse_ad(jac_alg::BVPJacobianAlgorithm)
    return __any_sparse_ad(jac_alg.bc_diffmode) ||
        __any_sparse_ad(jac_alg.nonbc_diffmode) ||
        __any_sparse_ad(jac_alg.diffmode)
end
@inline __any_sparse_ad(_) = false

function BVPJacobianAlgorithm(diffmode = missing; nonbc_diffmode = missing, bc_diffmode = missing)
    if diffmode !== missing
        bc_diffmode = bc_diffmode === missing ? diffmode : bc_diffmode
        nonbc_diffmode = nonbc_diffmode === missing ? diffmode : nonbc_diffmode
        return BVPJacobianAlgorithm(bc_diffmode, nonbc_diffmode, diffmode)
    else
        diffmode = nothing
        bc_diffmode = bc_diffmode === missing ? nothing : bc_diffmode
        nonbc_diffmode = nonbc_diffmode === missing ? nothing : nonbc_diffmode
        return BVPJacobianAlgorithm(bc_diffmode, nonbc_diffmode, diffmode)
    end
end

"""
    concrete_jacobian_algorithm(jac_alg, prob, alg)
    concrete_jacobian_algorithm(jac_alg, problem_type, prob, alg)

If user provided all the required fields, then return the user provided algorithm.
Otherwise, based on the problem type and the algorithm, decide the missing fields.

For example, for `TwoPointBVProblem`, the `bc_diffmode` is set to
`AutoSparse(AutoForwardDiff())` while for `StandardBVProblem`, the `bc_diffmode` is set to
`AutoForwardDiff()`.
"""
function concrete_jacobian_algorithm(jac_alg::BVPJacobianAlgorithm, prob::AbstractBVProblem, alg)
    return concrete_jacobian_algorithm(jac_alg, prob.problem_type, prob, alg)
end

# For multi-point BVP, we only care about bc_diffmode and nonbc_diffmode
function concrete_jacobian_algorithm(
        jac_alg::BVPJacobianAlgorithm, prob_type::StandardBVProblem, prob::BVProblem, alg
    )
    u0 = __extract_u0(prob.u0, prob.p, first(prob.tspan))
    bc_diffmode = jac_alg.bc_diffmode === nothing ? __default_bc_sparse_ad(u0) :
        jac_alg.bc_diffmode
    nonbc_diffmode = jac_alg.nonbc_diffmode === nothing ? __default_sparse_ad(u0) :
        jac_alg.nonbc_diffmode
    diffmode = jac_alg.diffmode === nothing ? nothing : jac_alg.diffmode
    return BVPJacobianAlgorithm(bc_diffmode, nonbc_diffmode, diffmode)
end

# For two-point BVP, we only care about diffmode
function concrete_jacobian_algorithm(
        jac_alg::BVPJacobianAlgorithm, prob_type::TwoPointBVProblem, prob::BVProblem, alg
    )
    u0 = __extract_u0(prob.u0, prob.p, first(prob.tspan))
    diffmode = jac_alg.diffmode === nothing ? __default_sparse_ad(u0) : jac_alg.diffmode
    bc_diffmode = jac_alg.bc_diffmode === nothing ? nothing : jac_alg.bc_diffmode
    nonbc_diffmode = jac_alg.nonbc_diffmode === nothing ? nothing : jac_alg.nonbc_diffmode
    return BVPJacobianAlgorithm(bc_diffmode, nonbc_diffmode, diffmode)
end

function concrete_jacobian_algorithm(jac_alg::BVPJacobianAlgorithm, prob_type, prob::SecondOrderBVProblem, alg)
    u0 = __extract_u0(prob.u0, prob.p, first(prob.tspan))
    diffmode = jac_alg.diffmode === nothing ? __default_sparse_ad(u0) : jac_alg.diffmode
    bc_diffmode = jac_alg.bc_diffmode === nothing ?
        (
            prob_type isa TwoPointSecondOrderBVProblem ? __default_bc_sparse_ad :
            __default_nonsparse_ad
        )(u0) : jac_alg.bc_diffmode
    nonbc_diffmode = jac_alg.nonbc_diffmode === nothing ? __default_sparse_ad(u0) :
        jac_alg.nonbc_diffmode

    return BVPJacobianAlgorithm(bc_diffmode, nonbc_diffmode, diffmode)
end

@inline function __default_sparse_ad(x::AbstractArray{T}) where {T}
    return isbitstype(T) ? __default_sparse_ad(T) : __default_sparse_ad(first(x))
end
@inline __default_sparse_ad(x::T) where {T} = __default_sparse_ad(T)
@inline __default_sparse_ad(::Type{<:Complex}) = AutoSparse(
    AutoFiniteDiff(), sparsity_detector = TracerLocalSparsityDetector(),
    coloring_algorithm = GreedyColoringAlgorithm()
)
@inline function __default_sparse_ad(::Type{T}) where {T}
    return AutoSparse(
        ifelse(ForwardDiff.can_dual(T), AutoForwardDiff(), AutoFiniteDiff()),
        sparsity_detector = TracerLocalSparsityDetector(),
        coloring_algorithm = GreedyColoringAlgorithm()
    )
end

@inline function __default_bc_sparse_ad(x::AbstractArray{T}) where {T}
    return isbitstype(T) ? __default_bc_sparse_ad(T) : __default_bc_sparse_ad(first(x))
end
@inline __default_bc_sparse_ad(x::T) where {T} = __default_bc_sparse_ad(T)
@inline __default_bc_sparse_ad(::Type{<:Complex}) = AutoSparse(
    AutoFiniteDiff(), sparsity_detector = TracerLocalSparsityDetector(),
    coloring_algorithm = GreedyColoringAlgorithm()
)
@inline function __default_bc_sparse_ad(::Type{T}) where {T}
    return AutoSparse(
        ifelse(ForwardDiff.can_dual(T), AutoForwardDiff(), AutoFiniteDiff()),
        sparsity_detector = TracerLocalSparsityDetector(),
        coloring_algorithm = GreedyColoringAlgorithm()
    )
end

@inline __default_coloring_algorithm(_) = GreedyColoringAlgorithm()
@inline __default_coloring_algorithm(diffmode::AutoSparse) = isnothing(diffmode) ?
    GreedyColoringAlgorithm() :
    diffmode.coloring_algorithm
@inline __default_sparsity_detector(_) = TracerLocalSparsityDetector()
@inline __default_sparsity_detector(diffmode::AutoSparse) = isnothing(diffmode) ?
    TracerLocalSparsityDetector() :
    diffmode.sparsity_detector

@inline function __default_nonsparse_ad(x::AbstractArray{T}) where {T}
    return isbitstype(T) ? __default_nonsparse_ad(T) : __default_nonsparse_ad(first(x))
end
@inline __default_nonsparse_ad(x::T) where {T} = __default_nonsparse_ad(T)
@inline __default_nonsparse_ad(::Type{<:Complex}) = AutoFiniteDiff()
@inline function __default_nonsparse_ad(::Type{T}) where {T}
    return ifelse(ForwardDiff.can_dual(T), AutoForwardDiff(), AutoFiniteDiff())
end

# This can cause Type Instability
function concretize_jacobian_algorithm(alg, prob)
    @set! alg.jac_alg = concrete_jacobian_algorithm(alg.jac_alg, prob, alg)
    return alg
end

@inline __needs_diffcache(::AutoForwardDiff) = true
@inline __needs_diffcache(::AutoPolyesterForwardDiff) = true
@inline __needs_diffcache(ad::AutoSparse) = __needs_diffcache(ADTypes.dense_ad(ad))
@inline __needs_diffcache(_) = false
@inline function __needs_diffcache(jac_alg::BVPJacobianAlgorithm)
    return __needs_diffcache(jac_alg.diffmode) ||
        __needs_diffcache(jac_alg.bc_diffmode) ||
        __needs_diffcache(jac_alg.nonbc_diffmode)
end

function __maybe_allocate_diffcache(x, chunksize, jac_alg)
    return __needs_diffcache(jac_alg) ?
        DiffCache(x, chunksize; warn_on_resize = false) : x
end
function __maybe_allocate_diffcache(x::DiffCache, chunksize)
    return DiffCache(zero(x.du), chunksize; warn_on_resize = false)
end

# DiffCache
struct DiffCacheNeeded end
struct NoDiffCacheNeeded end

@inline __cache_trait(::AutoForwardDiff) = DiffCacheNeeded()
@inline __cache_trait(ad::AutoSparse) = __cache_trait(ADTypes.dense_ad(ad))
@inline function __cache_trait(jac_alg::BVPJacobianAlgorithm)
    return __needs_diffcache(jac_alg) ? DiffCacheNeeded() : NoDiffCacheNeeded()
end
@inline __cache_trait(_) = NoDiffCacheNeeded()

SciMLBase.isautodifferentiable(::AbstractBoundaryValueDiffEqAlgorithm) = true
SciMLBase.allows_arbitrary_number_types(::AbstractBoundaryValueDiffEqAlgorithm) = true
SciMLBase.allowscomplex(alg::AbstractBoundaryValueDiffEqAlgorithm) = true

module BoundaryValueDiffEqCore

using Adapt: adapt
using ADTypes: ADTypes, AbstractADType, AutoSparse, AutoForwardDiff, AutoFiniteDiff,
    NoSparsityDetector, KnownJacobianSparsityDetector, AutoPolyesterForwardDiff
using ArrayInterface: parameterless_type, fast_scalar_indexing
using ConcreteStructs: @concrete
using DiffEqBase: DiffEqBase, solve
using ForwardDiff: ForwardDiff, pickchunksize
using Integrals: Integrals, IntegralProblem
using LinearAlgebra
using LineSearch: BackTracking
using NonlinearSolveFirstOrder: NonlinearSolvePolyAlgorithm
using NonlinearSolveBase: NonlinearVerbosity
using OptimizationBase: OptimizationBase, OptimizationVerbosity
using PreallocationTools: PreallocationTools, DiffCache, get_tmp
using RecursiveArrayTools: AbstractVectorOfArray, VectorOfArray, DiffEqArray
using Reexport: @reexport
using SciMLBase: SciMLBase, AbstractBVProblem, AbstractDiffEqInterpolation,
    StandardBVProblem, StandardSecondOrderBVProblem, __solve, _unwrap_val
using SciMLLogging: SciMLLogging, @SciMLMessage, Silent, DebugLevel,
    InfoLevel, WarnLevel, ErrorLevel, @verbosity_specifier, AbstractVerbositySpecifier,
    None, Minimal, Standard, Detailed, All, AbstractMessageLevel
using Setfield: @set!, @set
using SparseArrays: sparse
using SparseConnectivityTracer: SparseConnectivityTracer, TracerLocalSparsityDetector
using SparseMatrixColorings: GreedyColoringAlgorithm
using SciMLStructures: SciMLStructures

@reexport using NonlinearSolveFirstOrder, SciMLBase

include("verbosity.jl")
include("types.jl")
include("solution_utils.jl")
include("utils.jl")
include("internal_problems.jl")
include("algorithms.jl")
include("abstract_types.jl")
include("alg_utils.jl")
include("default_internal_solve.jl")
include("calc_errors.jl")

function SciMLBase.__solve(
        prob::AbstractBVProblem,
        alg::AbstractBoundaryValueDiffEqAlgorithm, args...; kwargs...
    )
    cache = SciMLBase.__init(prob, alg, args...; kwargs...)
    return SciMLBase.solve!(cache)
end

export AbstractBoundaryValueDiffEqAlgorithm, BVPJacobianAlgorithm
export DefectControl, GlobalErrorControl, SequentialErrorControl, HybridErrorControl,
    NoErrorControl
export HOErrorControl, REErrorControl
export integral
export BVPVerbosity, _process_verbose_param, DEFAULT_VERBOSE

end

using InteractiveUtils, Test

@info sprint(InteractiveUtils.versioninfo)

@testset "BoundaryValueDiffEqCore.jl" begin
    @testset "Aqua" begin
        using Aqua, BoundaryValueDiffEqCore

        Aqua.test_all(BoundaryValueDiffEqCore; piracies = false, ambiguities = false, stale_deps = false)
        Aqua.test_stale_deps(BoundaryValueDiffEqCore; ignore = [:TimerOutputs])
        Aqua.test_piracies(BoundaryValueDiffEqCore)
        Aqua.test_ambiguities(BoundaryValueDiffEqCore; recursive = false)
    end

    @testset "_process_verbose_param foreign AbstractVerbositySpecifier" begin
        # DiffEqBase.DEVerbosity is a foreign AbstractVerbositySpecifier that
        # can flow in via DiffEqBase's `solve`/`init` default `verbose` kwarg.
        # It must not hit a MethodError at precompile time; it should fall
        # back to BVP's own DEFAULT_VERBOSE (a BVPVerbosity).
        using BoundaryValueDiffEqCore, DiffEqBase
        result = BoundaryValueDiffEqCore._process_verbose_param(DiffEqBase.DEFAULT_VERBOSE)
        @test result isa BoundaryValueDiffEqCore.BVPVerbosity
        @test result === BoundaryValueDiffEqCore.DEFAULT_VERBOSE
    end
end

@inline __default_cost(::Nothing) = (x, p) -> 0.0
@inline __default_cost(f) = f
@inline __build_cost(::Nothing, cache, mesh, M; kwargs...) = (x, p) -> 0.0
@inline function __build_cost(fun, cache, mesh, M; tune_parameters = false, p = nothing)
    if tune_parameters && SciMLStructures.isscimlstructure(p)
        # When tune_parameters=true, the state vector is augmented with tunable params
        # Extract them and use SciMLStructures.replace to update p for the cost function
        tunable_part, _ = SciMLStructures.canonicalize(SciMLStructures.Tunable(), p)
        l_params = length(tunable_part)
        length_u = M - l_params
        cost_fun = @views function (u, p_orig)
            newy = eachcol(reshape(u, M, :))
            # Extract tunable params from first mesh point (same at all points)
            params_from_u = u[(length_u + 1):M]
            new_p = SciMLStructures.replace(SciMLStructures.Tunable(), p_orig, params_from_u)
            eval_sol = EvalSol(newy, mesh, cache)
            return fun(eval_sol, new_p)
        end
    elseif tune_parameters && !isnothing(p)
        length_u = M - length(p)
        cost_fun = @views function (u, p)
            # When tune_parameters=true, the state vector is augmented with tunable params
            newy = eachcol(reshape(u, M, :))
            params_from_u = u[(length_u + 1):M]
            eval_sol = EvalSol(newy, mesh, cache)
            return fun(eval_sol, params_from_u)
        end
    else
        cost_fun = @views function (u, p)
            # simple recursive unflatten
            newy = eachcol(reshape(u, M, :))
            eval_sol = EvalSol(newy, mesh, cache)
            return fun(eval_sol, p)
        end
    end
    return cost_fun
end

@inline function __extract_lcons_ucons(
        prob::AbstractBVProblem, ::Type{T}, M, N, bcresid_prototype, f_prototype
    ) where {T}
    L_f_prototype = length(f_prototype)
    L_bcresid_prototype = length(bcresid_prototype)
    lcons = if isnothing(prob.lcons)
        zeros(T, L_bcresid_prototype + (N - 1) * L_f_prototype)
    else
        lcons_length = length(prob.lcons)
        vcat(prob.lcons, zeros(T, N * M - lcons_length))
    end
    ucons = if isnothing(prob.ucons)
        zeros(T, L_bcresid_prototype + (N - 1) * L_f_prototype)
    else
        ucons_length = length(prob.ucons)
        vcat(prob.ucons, zeros(T, N * M - ucons_length))
    end
    return lcons, ucons
end

@inline function __extract_lcons_ucons(
        prob::AbstractBVProblem, ::Type{T}, M, N, bcresid_prototype, ::Nothing
    ) where {T}
    lcons = zeros(T, N * M)
    ucons = zeros(T, N * M)
    return lcons, ucons
end

@inline function __extract_lcons_ucons(prob::AbstractBVProblem, ::Type{T}, M, N) where {T}
    lcons = if isnothing(prob.lcons)
        zeros(T, N * M)
    else
        lcons_length = length(prob.lcons)
        vcat(prob.lcons, zeros(T, N * M - lcons_length))
    end
    ucons = if isnothing(prob.ucons)
        zeros(T, N * M)
    else
        ucons_length = length(prob.ucons)
        vcat(prob.ucons, zeros(T, N * M - ucons_length))
    end
    return lcons, ucons
end

@inline function __extract_lb_ub(prob::AbstractBVProblem, ::Type{T}, M, N) where {T}
    lb = if isnothing(prob.lb)
        nothing
    else
        repeat(prob.lb, N)
    end
    ub = if isnothing(prob.ub)
        nothing
    else
        repeat(prob.ub, N)
    end
    return lb, ub
end

function integral(fun, domain)
    prob = IntegralProblem(fun, domain)
    sol = SciMLBase.solve(prob, Integrals.QuadGKJL())
    return sol.u
end

"""
    __construct_internal_problem

Constructs the internal problem according to the specified boundary value problem and the
selected algorithm. Depending on the formulation, it returns either a `NonlinearProblem` or an `OptimizationProblem`.
"""
function __construct_internal_problem(
        prob, pt::StandardBVProblem, alg, loss, jac, jac_prototype, resid_prototype,
        bcresid_prototype, f_prototype, y, p, M::Int, N::Int, cost_fun
    )
    T = eltype(y)
    iip = SciMLBase.isinplace(prob)
    if !isnothing(alg.nlsolve) || (isnothing(alg.nlsolve) && isnothing(alg.optimize))
        nlf = NonlinearFunction{iip}(
            loss; jac = jac, resid_prototype = resid_prototype,
            jac_prototype = jac_prototype
        )
        return __internal_nlsolve_problem(prob, resid_prototype, y, nlf, y, p)
    else
        optf = OptimizationFunction{true}(
            cost_fun,
            AutoSparse(
                get_dense_ad(alg.jac_alg.nonbc_diffmode),
                sparsity_detector = __default_sparsity_detector(alg.jac_alg.diffmode)
            ),
            cons = loss,
            cons_j = jac,
            cons_jac_prototype = sparse(jac_prototype)
        )
        lcons, ucons = __extract_lcons_ucons(prob, T, M, N, bcresid_prototype, f_prototype)
        lb, ub = __extract_lb_ub(prob, T, M, N)

        return __internal_optimization_problem(
            prob, optf, y, p; lcons = lcons, ucons = ucons, lb = lb, ub = ub
        )
    end
end

function __construct_internal_problem(
        prob, pt::TwoPointBVProblem, alg, loss, jac, jac_prototype, resid_prototype,
        bcresid_prototype, f_prototype, y, p, M::Int, N::Int, cost_fun
    )
    T = eltype(y)
    iip = SciMLBase.isinplace(prob)
    if !isnothing(alg.nlsolve) || (isnothing(alg.nlsolve) && isnothing(alg.optimize))
        nlf = NonlinearFunction{iip}(
            loss; jac = jac, resid_prototype = resid_prototype,
            jac_prototype = jac_prototype
        )
        return __internal_nlsolve_problem(prob, resid_prototype, y, nlf, y, p)
    else
        optf = OptimizationFunction{true}(
            cost_fun,
            AutoSparse(
                get_dense_ad(alg.jac_alg.diffmode),
                sparsity_detector = __default_sparsity_detector(alg.jac_alg.diffmode)
            ),
            cons = loss,
            cons_j = jac,
            cons_jac_prototype = sparse(jac_prototype)
        )
        lcons, ucons = __extract_lcons_ucons(prob, T, M, N, bcresid_prototype, f_prototype)
        lb, ub = __extract_lb_ub(prob, T, M, N)

        return __internal_optimization_problem(
            prob, optf, y, p; lcons = lcons, ucons = ucons, lb = lb, ub = ub
        )
    end
end

# Single shooting use diffmode for StandardBVProblem and TwoPointBVProblem
# Version with Val{iip} for type stability
function __construct_internal_problem(
        prob::SciMLBase.AbstractBVProblem, alg, loss, jac,
        jac_prototype, resid_prototype, y, p, M::Int, N::Int, ::Nothing, ::Val{iip}
    ) where {iip}
    T = eltype(y)
    if !isnothing(alg.nlsolve) || (isnothing(alg.nlsolve) && isnothing(alg.optimize))
        nlf = NonlinearFunction{iip}(
            loss; jac = jac, resid_prototype = resid_prototype,
            jac_prototype = jac_prototype
        )
        return __internal_nlsolve_problem(prob, resid_prototype, y, nlf, y, p)
    else
        optf = OptimizationFunction{iip}(
            __default_cost(prob.f.cost),
            AutoSparse(
                get_dense_ad(alg.jac_alg.diffmode),
                sparsity_detector = __default_sparsity_detector(alg.jac_alg.diffmode)
            ),
            cons = loss,
            cons_j = jac,
            cons_jac_prototype = sparse(jac_prototype)
        )
        lcons, ucons = __extract_lcons_ucons(prob, T, M, N)
        lb, ub = __extract_lb_ub(prob, T, M, N)

        return __internal_optimization_problem(
            prob, optf, y, p; lcons = lcons, ucons = ucons, lb = lb, ub = ub
        )
    end
end

# Fallback version without Val{iip} - extracts iip at runtime (for backwards compatibility)
function __construct_internal_problem(
        prob::SciMLBase.AbstractBVProblem, alg, loss, jac,
        jac_prototype, resid_prototype, y, p, M::Int, N::Int, ::Nothing
    )
    return __construct_internal_problem(
        prob, alg, loss, jac, jac_prototype, resid_prototype,
        y, p, M, N, nothing, Val(SciMLBase.isinplace(prob))
    )
end

# Multiple shooting always use inplace version internal problem constructor
function __construct_internal_problem(
        prob, pt::StandardBVProblem, alg, loss, jac, jac_prototype,
        resid_prototype, y, p, M::Int, N::Int, ::Nothing, ::Nothing
    )
    T = eltype(y)
    if !isnothing(alg.nlsolve) || (isnothing(alg.nlsolve) && isnothing(alg.optimize))
        nlf = NonlinearFunction{true}(
            loss; jac = jac, resid_prototype = resid_prototype,
            jac_prototype = jac_prototype
        )
        return __internal_nlsolve_problem(prob, resid_prototype, y, nlf, y, p)
    else
        optf = OptimizationFunction{true}(
            __default_cost(prob.f.cost),
            AutoSparse(
                get_dense_ad(alg.jac_alg.nonbc_diffmode),
                sparsity_detector = __default_sparsity_detector(alg.jac_alg.nonbc_diffmode)
            ),
            cons = loss,
            cons_j = jac,
            cons_jac_prototype = sparse(jac_prototype)
        )
        lcons, ucons = __extract_lcons_ucons(prob, T, M, N, bcresid_prototype, f_prototype)
        lb, ub = __extract_lb_ub(prob, T, M, N)

        return __internal_optimization_problem(
            prob, optf, y, p; lcons = lcons, ucons = ucons, lb = lb, ub = ub
        )
    end
end
function __construct_internal_problem(
        prob, pt::TwoPointBVProblem, alg, loss, jac, jac_prototype,
        resid_prototype, y, p, M::Int, N::Int, ::Nothing, ::Nothing
    )
    T = eltype(y)
    #iip = SciMLBase.isinplace(prob)
    if !isnothing(alg.nlsolve) || (isnothing(alg.nlsolve) && isnothing(alg.optimize))
        nlf = NonlinearFunction{true}(
            loss; jac = jac, resid_prototype = resid_prototype,
            jac_prototype = jac_prototype
        )
        return __internal_nlsolve_problem(prob, resid_prototype, y, nlf, y, p)
    else
        optf = OptimizationFunction{true}(
            __default_cost(prob.f.cost),
            AutoSparse(
                get_dense_ad(alg.jac_alg.diffmode),
                sparsity_detector = __default_sparsity_detector(alg.jac_alg.nonbc_diffmode)
            ),
            cons = loss,
            cons_j = jac,
            cons_jac_prototype = sparse(jac_prototype)
        )
        lcons, ucons = __extract_lcons_ucons(prob, T, M, N, bcresid_prototype, f_prototype)
        lb, ub = __extract_lb_ub(prob, T, M, N)

        return __internal_optimization_problem(
            prob, optf, y, p; lcons = lcons, ucons = ucons, lb = lb, ub = ub
        )
    end
end

# SecondOrderBVProblem
function __construct_internal_problem(
        prob, pt::StandardSecondOrderBVProblem, alg, loss, jac,
        jac_prototype, resid_prototype, y, p, M::Int, N::Int
    )
    T = eltype(y)
    iip = SciMLBase.isinplace(prob)
    if !isnothing(alg.nlsolve) || (isnothing(alg.nlsolve) && isnothing(alg.optimize))
        nlf = NonlinearFunction{iip}(
            loss; jac = jac, resid_prototype = resid_prototype,
            jac_prototype = jac_prototype
        )
        return __internal_nlsolve_problem(prob, resid_prototype, y, nlf, y, p)
    else
        optf = OptimizationFunction{iip}(
            __default_cost(prob.f.cost),
            AutoSparse(
                get_dense_ad(alg.jac_alg.nonbc_diffmode),
                sparsity_detector = __default_sparsity_detector(alg.jac_alg.nonbc_diffmode)
            ),
            cons = loss,
            cons_j = jac,
            cons_jac_prototype = sparse(jac_prototype)
        )
        lcons, ucons = __extract_lcons_ucons(prob, T, M, N)
        lb, ub = __extract_lb_ub(prob, T, M, N)

        return __internal_optimization_problem(
            prob, optf, y, p; lcons = lcons, ucons = ucons, lb = lb, ub = ub
        )
    end
end
function __construct_internal_problem(
        prob, pt::TwoPointSecondOrderBVProblem, alg, loss, jac,
        jac_prototype, resid_prototype, y, p, M::Int, N::Int
    )
    T = eltype(y)
    iip = SciMLBase.isinplace(prob)
    if !isnothing(alg.nlsolve) || (isnothing(alg.nlsolve) && isnothing(alg.optimize))
        nlf = NonlinearFunction{iip}(
            loss; jac = jac, resid_prototype = resid_prototype,
            jac_prototype = jac_prototype
        )
        return __internal_nlsolve_problem(prob, resid_prototype, y, nlf, y, p)
    else
        optf = OptimizationFunction{true}(
            __default_cost(prob.f),
            AutoSparse(
                get_dense_ad(alg.jac_alg.diffmode),
                sparsity_detector = __default_sparsity_detector(alg.jac_alg.nonbc_diffmode)
            ),
            cons = loss,
            cons_j = jac,
            cons_jac_prototype = sparse(jac_prototype)
        )
        lcons, ucons = __extract_lcons_ucons(prob, T, M, N)
        lb, ub = __extract_lb_ub(prob, T, M, N)

        return __internal_optimization_problem(
            prob, optf, y, p; lcons = lcons, ucons = ucons, lb = lb, ub = ub
        )
    end
end

# Algorithms
"""
    AbstractBoundaryValueDiffEqAlgorithm

Abstract type for all boundary value problem algorithms.
"""
abstract type AbstractBoundaryValueDiffEqAlgorithm <: SciMLBase.AbstractBVPAlgorithm end

@inline __nameof(::T) where {T} = nameof(T)
@inline __nameof(::Type{T}) where {T} = nameof(T)

## Disable the ugly verbose printing by default
@inline __modifier_text!(list, fieldname, field) = push!(list, "$fieldname = $(field)")
@inline __modifier_text!(list, fieldname, ::Nothing) = list
@inline __modifier_text!(list, fieldname, ::Missing) = list
@inline function __modifier_text!(list, fieldname, field::SciMLBase.AbstractODEAlgorithm)
    return push!(list, "$fieldname = $(__nameof(field))()")
end

function Base.show(io::IO, alg::AbstractBoundaryValueDiffEqAlgorithm)
    print(io, "$(__nameof(alg))(")
    modifiers = String[]
    for field in fieldnames(typeof(alg))
        __modifier_text!(modifiers, field, getfield(alg, field))
    end
    print(io, join(modifiers, ", "))
    return print(io, ")")
end

# Check what's the internal solver, nonlinear or optimization?
function __internal_solver(alg::AbstractBoundaryValueDiffEqAlgorithm)
    # We don't allow both `nlsolve` and `optimize` to be specified at the same time
    (isnothing(alg.nlsolve) && isnothing(alg.optimize)) &&
        error("Either `nlsolve` or `optimize` must be specified in the algorithm, but not both.")
    isnothing(alg.nlsolve) && return alg.optimize
    return isnothing(alg.optimize) && return alg.nlsolve
end
